*+
*+
*+    Source Module => HANDLES.PRG
*+
*+    Functions: Function FileTest()
*+               Function NumFiles()
*+               Function FilesMax()
*+               Function FilesFree()
*+
*+    Reformatted by Click! 1.11 on Sep-21-1997 at 11:00 pm
*+
*+

/*

gene@fundraiser-software.com (Gene Weinbeck) 30 Jul 1997 writes:

:>Is there a freeware or shareware library out there that contains a
:>function that will tell me how many file handles are available (lesser
:>of FILES= in config.sys and net.cfg and in the CLIPPER= statement)?
:>
:>Gene Weinbeck
:>President, Professional Support Software
:>author of the FundRaiser family of donor management software
:>gene@fundraiser-software.com
:>http://www.fundraiser-software.com

Try this, use if you want.

FILETEST.PRG  - This routine is a replacement for the
                Clipper Tools functions:
                Numfiles, FilesMax, and FilesFree.

Gary Crossno

*/

* FileTest()    Does actual count of file handles available
* NumFiles()    Replacement of CT function
* FilesFree()   Replacement of CT function
* FilesMax()    Replacement of CT function

******************************
* FILETEST FUNCTION
* PARAM:  nType - Numeric var to determine what count to return.
*             1 = Add 7 to count for open handles
*             2 = Add 2 to count for EXE and swap file.
*             3 = return actual number of handles avail.
*************************************

*+
*+
*+    Function FileTest()
*+
*+    Called from ( handles.prg  )   1 - function numfiles()
*+                                   1 - function filesmax()
*+                                   1 - function filesfree()
*+
*+
*+
function FileTest( nType )

local nX
local nArrLen
local aHand   := {}
local nRet    := 0
local nHand

do while .t.
   nHand := fopen( 'nul' )
   IF nHand > 0
      aadd( aHand, nHand )
   else
      exit
   endif
enddo

nArrLen := len( aHand )

for nX := 1 to nArrLen
   fclose( aHand[ nX ] )
next

IF nArrLen > 0
   do case
   case nType == 1
      nRet := nArrLen + ( aHand[ 1 ] - 1 )
   case nType == 2
      nRet := nArrLen + 1
   case nType == 3
      nRet := nArrlen
   endcase
endif

return nRet

*************** CLIPPER TOOLS REPLACEMENT FUNCTIONS *************************
* The following functions are replacements for Clipper Tools functions
* found in the application.

*************************
* NUMFILES FUNC
*       Calls FileTest() and returns the TOTAL NUMBER OF FILE HANDLES
*       value from FileTest()
****************

*+
*+
*+    Function NumFiles()
*+
*+
*+
function NumFiles()

return FileTest( 1 )

*************************
* FILESMAX FUNC
*         Calls FileTest() and returns the MAXIMUM NUMBER OF FILE HANDLES
*         value that the app started with from FileTest()
****************

*+
*+
*+    Function FilesMax()
*+
*+
*+
function FilesMax()

return FileTest( 2 )

*************************
* FILESFREE FUNCTION
*       Calls FileTest() and returns the CURRENT AVAILABLE FILE HANDLES
*       value from FileTest()
****************

*+
*+
*+    Function FilesFree()
*+
*+
*+
function FilesFree()

return FileTest( 3 )

*+ EOF: HANDLES.PRG
